SystemOrganization addCategory: #'OB-Tests-Core'!

OBBrowser subclass: #OBFakeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBFakeBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2007 00:18'!
cmdBeZ
	^ OBPluggableCommand new
		label: 'become z';
		active: [:node :col | col isSelected: node];
		action: [:node :col | node beZ. node announceChangedWith: col];
		yourself! !

!OBFakeBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2007 00:34'!
cmdCreateZ
	^ OBPluggableCommand new
		label: 'create z';
		action: [:node :col | node createZ announceSelectionWith: col];
		active: [:node :col | (col isSelected: node) not];
		yourself! !

!OBFakeBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2007 00:20'!
cmdDelete
	^ OBPluggableCommand new
		label: 'delete';
		action: [:node :col | node delete. node announceDeletionWith: col];
		active: [:node :col | col isSelected: node];
		yourself! !

!OBFakeBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2007 00:24'!
cmdDeleteRoot
	^ OBPluggableCommand new
		label: 'delete root';
		action: [:node :col | node root announceDeletionWith: col];
		active: [:node :col | col isSelected: node];
		yourself! !

OBBrowser subclass: #OBFakeCommandBrowser
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBFakeCommandBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 10/4/2006 10:04'!
defaultMetaNode
	^ OBFakeNode metagraph! !

!OBFakeCommandBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 10/4/2006 10:04'!
defaultRootNode
	^ OBFakeNode new! !

!OBFakeCommandBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2007 19:22'!
withAction: aBlock
	| browser |
	browser _ self basicNew initialize.
	browser action: aBlock.
	self panels do: [:ea | browser addPanel: ea].
	browser setMetaNode: self defaultMetaNode node: self defaultRootNode.
	^ browser! !

!OBFakeCommandBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 10/4/2006 09:59'!
action
	^ action! !

!OBFakeCommandBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 10/4/2006 09:59'!
action: aBlock	
	action _ aBlock! !

!OBFakeCommandBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2007 19:04'!
cmdPluggable
	^ OBPluggableCommand action: action! !

TestCase subclass: #OBAnnouncerTest
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBAnnouncerTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/3/2006 21:21'!
testBlock
	| announcement |
	announcer _ OBAnnouncer new.
	announcer
		observe: OBSelectionChanged
		do: [:arg | announcement _ arg].
	announcer announce: OBSelectionChanged.
	self assert: (announcement isKindOf: OBSelectionChanged)! !

!OBAnnouncerTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/3/2006 21:21'!
testInstance
	| announcement |
	announcer _ OBAnnouncer new.
	announcer
		observe: OBSelectionChanged
		do: [:arg | announcement _ arg].
	announcer announce: OBSelectionChanged new.
	self assert: (announcement isKindOf: OBSelectionChanged)! !

!OBAnnouncerTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/3/2006 21:22'!
testMessage
	| announcement |
	announcer _ OBAnnouncer new.
	announcer
		observe: OBSelectionChanged
		send: #value:
		to: [:ann | announcement _ ann].
	announcer announce: OBSelectionChanged.
	self assert: (announcement isKindOf: OBSelectionChanged)! !

TestCase subclass: #OBBrowserCommandsTest
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBBrowserCommandsTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2007 00:46'!
test01ScanFindsCommandCreationMethods
	| called scan |
	called := false.
	browser := OBFakeCommandBrowser withAction: [called := true].
	scan := browser announce: OBNodeCommandScan.
	(scan commandsOn: nil for: nil) first execute.
	self assert: called! !

TestCase subclass: #OBBrowserTest
	instanceVariableNames: 'model morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 00:13'!
isAbstract
	^ self name = #OBBrowserTest! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 9/14/2005 22:22'!
assertAListIncludes: anArrayOfStrings
	self listMorphs 
			detect: [:m | | list |
					list _ m getListDelicately collect: [:ea | ea  asString withBlanksTrimmed].
					list includesAllOf: anArrayOfStrings]
			ifNone: [self assert: false].! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 3/14/2004 13:10'!
assertAListMatches: strings
	| list |
	self listMorphs
			detect:	[:m | 
					list _ m getListDelicately.
					(list size = strings size) and: [list includesAllOf: strings]]
			ifNone: [self assert: false].! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 3/11/2004 23:03'!
assertButtonSelected: aString
	| button |
	button _ (self morphsOfClass: PluggableButtonMorph) 
				detect: [:m | m label contents = aString]
				ifNone: [self signalFailure: 'No button labeled ', aString].
	self assert: button isOn! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 1/8/2005 12:01'!
assertCurrentItemIs: aString
	self assert: self currentItem withBlanksTrimmed = aString! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 3/14/2004 12:47'!
assertListAt: index contains: items
	| list |
	list _ self listItemsAt: index.
	self assert: (list size = items size).
	self assert: (list includesAllOf: items).! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 9/14/2005 23:05'!
assertListAt: index includes: items
	| list |
	list _ (self listItemsAt: index) collect: [:ea | ea asString withBlanksTrimmed].
	self assert: (list includesAllOf: items).! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 1/23/2004 22:35'!
assertMenuContains: aString
	| item |
	item _ self menuItemNamed: aString.
	self assert: item notNil! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 3/24/2007 00:19'!
assertNoButtonsVisible
	self assert: ((morph findDeeplyA: OBPaneScroller)
					findDeeplyA: PluggableButtonMorph) isNil.! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 2/29/2004 19:38'!
assertSelectedTextIs: aString
	| text selection |
	morph _ self textMorph.
	text _ morph getText.
	selection _ morph getSelection.
	self assert: (text atAll: selection) asString = aString.! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 3/16/2004 20:33'!
assertTextIs: aString
	| actual |
	actual _ self textMorph text.
	self assert: actual = aString.! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 2/29/2004 19:33'!
assertTextIsSelected
	self assert: self textMorph getSelection size = self textMorph getText size! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 3/11/2004 23:02'!
clickButtonLabeled: aString
	| button |
	button _ (self morphsOfClass: PluggableButtonMorph) 
				detect: [:m | m label contents = aString]
				ifNone: [self signalFailure: 'No button labeled ', aString].
	button performAction! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 9/14/2005 22:22'!
currentItem
	^ self currentList selection asString! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 5/13/2004 10:59'!
currentList
	^ self listMorphs reversed 
						detect: [:list | list selection notNil]
						ifNone: [self signalFailure: 'No item is currently selected']! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 3/14/2004 13:11'!
denyAListIncludes: anArrayOfStrings
	self listMorphs 
			detect: [:m | m getListDelicately includesAllOf: anArrayOfStrings]
			ifNone: [^ self].
	self assert: false.! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 12/17/2003 15:08'!
deselect: aString
	| listMorph |
	listMorph _ self findListContaining: aString.
	listMorph changeModelSelection: 0.! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/28/2004 13:50'!
drag: nodeName
	| item list |
	item _ StringMorph contents: nodeName asString.
	list _ self findListContaining: nodeName.
	^ list model dragPassengerFor: item inMorph: list! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/28/2004 13:50'!
drag: passangerName to: targetName
	| passanger |
	passanger _ self drag: passangerName.
	self drop: passanger on: targetName! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/28/2004 13:50'!
drop: aPassenger on: targetName
	| list transfer event |
	list _ self findListContaining: targetName.
	self assert: list notNil.
	transfer _ TransferMorph withPassenger: aPassenger.
	transfer dragTransferType: #OmniBrowser.
	event _ self mouseMoveEventIn: targetName.
	self assert: (list model wantsDroppedMorph: transfer event: event inMorph: list).
	^ list model acceptDroppingMorph: transfer event: event inMorph: list! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/28/2004 13:52'!
editText: aString
	| textMorph |
	textMorph _ self textMorph.
	textMorph 
		selectAll;
		replaceSelectionWith: aString asText! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 9/14/2005 09:00'!
findListContaining: aString
	^ self listMorphs 
		detect: [:m | | list |
				list _ m getListDelicately collect: [:ea | ea asString withBlanksTrimmed].
				list includes: aString] 
		ifNone: [nil]! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 11/17/2004 23:45'!
forceLayout
	morph bounds: (6@6 corner: 606@406)! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 3/14/2004 13:11'!
listItemsAt: index
	^ (self listMorphs 
		at: index 
		ifAbsent: [self signalFailure: 'List ', index asString, ' does not exist'])
			getListDelicately
	! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
listMorphs
	^ self morphsOfClass: PluggableListMorph! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 1/26/2004 21:53'!
menuItemNamed: aString
	| lists current |
	lists _ self listMorphs.
	current _ lists reversed detect: [:list | list selection notNil].
	^ (current getMenu: true) itemWithWording: aString.
! !

!OBBrowserTest methodsFor: 'running' stamp: 'avi 9/17/2005 01:39'!
metagraph
	^ self browserClass defaultMetaNode! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
morphNamed: aString
	^ morph 
		findDeepSubmorphThat: [:m | m knownName = aString]
		ifAbsent: [self signalFailure: aString, 'not found']! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
morphsOfClass: aClass
	| found |
	found _ OrderedCollection new.
	morph allMorphsDo: [:m | (m isMemberOf: aClass) ifTrue: [found add: m]].
	^ found! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 3/14/2004 13:14'!
mouseMoveEventIn: name
	| rect plm |
	plm _ self findListContaining: name.
	rect _ plm listMorph rectForRow: (plm getListDelicately indexOf: name).
	^ MouseMoveEvent new
		setType: #mouseEnter
		startPoint: rect center + (rect width @ 0)
		endPoint: rect center
		trail: #()
		buttons: 4
		hand: ActiveHand
		stamp: Time millisecondClockValue! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 9/14/2005 09:01'!
select: aString
	"We don't use #getListDelicately because the user would have to scroll through the list
	to find the item we're selecting, thus triggering updates to the list."
	
	| listMorph list |
	listMorph _ self findListContaining: aString.
	self assert: listMorph notNil.
	listMorph model okToChange ifFalse: [^ self].
	list _ listMorph getListObtrusively collect: [:ea | ea asString withBlanksTrimmed].
	listMorph changeModelSelection: (list indexOf: aString)! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 1/23/2004 23:30'!
selectMenuItem: aString
	| item |
	item _ self menuItemNamed: aString.
	item ifNil: [self signalFailure: 'Menu item ''', aString, ''' does not exist.'].
	item doButtonAction! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 3/14/2004 13:46'!
selectSequence: aCollection
	| plm |
	aCollection withIndexDo: [:item :index | 
					plm _ self listMorphs at: index.
					plm changeModelSelection: (plm getListObtrusively indexOf: item)]! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 12/17/2003 15:08'!
setText: aString
	| textMorph |
	textMorph _ self textMorph.
	textMorph 
		selectAll;
		replaceSelectionWith: aString asText;
		accept.
	! !

!OBBrowserTest methodsFor: 'running' stamp: 'cwp 3/23/2007 23:56'!
setUp
	model _ self browserClass metaNode: self metagraph node: self node.
	morph _ OBMorphBuilder build: model.
	self forceLayout! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 11/6/2004 23:00'!
textMorph
	^ (self morphsOfClass: OBPluggableTextMorph) last! !

OBBrowserTest subclass: #OBFakeBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBFakeBrowserTest methodsFor: 'constants' stamp: 'cwp 3/12/2007 23:51'!
browserClass
	^ OBFakeBrowser! !

!OBFakeBrowserTest methodsFor: 'running' stamp: 'cwp 11/7/2004 21:27'!
metagraph
	^ OBFakeNode metagraph! !

!OBFakeBrowserTest methodsFor: 'running' stamp: 'cwp 12/17/2003 15:12'!
node
	^ OBFakeNode new! !

!OBFakeBrowserTest methodsFor: 'constants' stamp: 'cwp 12/5/2004 18:17'!
paneCount
	^ 4! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 3/14/2004 14:25'!
testAcceptText
	self select: #a.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #(aa ab ac).
	self assertTextIs: 'a'.
	self setText: 'x'.
	
	"This is a gratuitous refresh to make the test pass. It isn't necessary when the 
	browser is actually open. It's a deficiency of the test environment..."
	self listMorphs do: [:ea | ea update: #list].
	
	self assertListAt: 1 contains: #(x b c).
	self assertListAt: 2 contains: #(xa xb xc).
	self assertTextIs: 'x'
! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 1/7/2004 08:27'!
testAction
	self select: #a.
	self selectMenuItem:  'become z'.
	self assertListAt: 1 contains:  #(z b c)! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/28/2004 13:49'!
testConfirmAbandon
	self select: #a.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #(aa ab ac).
	self assertTextIs: 'a'.
	self editText: 'x'.
	[self select: #b]
		on: OBConfirmationRequest
		do: [:notification | notification cancel].
	self assertCurrentItemIs: #a.
	self assertTextIs: 'x'.
! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 4/17/2006 22:14'!
testConfirmClose
	| notification |
	self select: #a.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #(aa ab ac).
	self assertTextIs: 'a'.
	self editText: 'x'.
	[morph delete]
		on: OBConfirmationRequest
		do: [:ex | notification _ ex].
	self deny: notification isNil! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 11/23/2003 13:12'!
testCreateWindow
	self assert: (morph isKindOf: SystemWindow).
	self assert: (morph label = 'OmniBrowser').
! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 6/4/2006 12:18'!
testDeleteB
	self select: #b.
	self selectMenuItem: 'delete'.
	self assertListAt: 1 contains: #(a c).
	self assert: self listMorphs size = self paneCount.
	self assertTextIs: ''.! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 3/14/2004 17:20'!
testDeleteRootNode
	self select: #a.
	self selectMenuItem: 'delete root'.
	self denyAListIncludes: #(a b c).
	self assertTextIs: ''! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 8/26/2004 02:17'!
testDeselectA
	self select: #a.
	self deselect: #a.
	self assertListAt: 1 contains: #(a b c).
	self assert: self listMorphs size = self paneCount.
	self assertTextIs: ''.! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 6/4/2006 13:30'!
testDragAndDrop
	| node |
	self select: #a.
	node _ self drag: #ab.
	self assert: (node isKindOf: OBFakeNode).
	self assert: node name = #ab.
	self drop: node on: #c.
	self assertListAt: 1 contains: #(a b c).
	self assertCurrentItemIs: #c.
	self assertTextIs: 'c'.
	self assertListAt: 2 contains: #(cb).
! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 8/26/2004 02:17'!
testInitialDisplay
	self assert: self listMorphs size = self paneCount.
	self assertListAt: 1 contains: #(a b c).
	self assertTextIs: ''.
	! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 11/20/2004 21:00'!
testPanes
	| scroller |
	self 
		assert: (self morphsOfClass: PluggableListMorph) size = self paneCount.
	self assert: (self morphsOfClass: OBPluggableTextMorph) size = 1.
	scroller := self morphNamed: 'scroller'.
	self assert: scroller panes size = model navigationPanel minPanes! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 6/4/2006 13:29'!
testRefreshDirty

	self select: #a.
	self editText: 'x'.
	
	[self selectMenuItem: 'create z']
		on: OBConfirmationRequest
		do: [:request | request cancel].
	model announcer announce: (OBRefreshRequired new).
	
	self assertListAt: 1 contains: #(a b c z).
	self assertCurrentItemIs: #a.
	self assertTextIs: 'x'.
! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/7/2003 19:30'!
testSelectA
	self select: #a.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #(aa ab ac).
	self assertTextIs: 'a'! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/7/2003 19:30'!
testSelectC
	self select: #c.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #().
	self assertTextIs: 'c'! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'dvf 9/5/2005 18:10'!
testSelectionPath
	self select: #a.
	self select: #ab.
	self assert: ((model selectionPath collect: [:e | e item]) = (OrderedCollection with: 'a' with: 'b'))! !

TestCase subclass: #OBBuilderTest
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBBuilderTest methodsFor: 'accessing' stamp: 'cwp 3/15/2007 22:35'!
announcer
	^ OBAnnouncer new! !

!OBBuilderTest methodsFor: 'building' stamp: 'cwp 3/13/2007 22:23'!
browser
	^ OBBrowser metaNode: OBFakeNode metagraph node: OBFakeNode new.! !

!OBBuilderTest methodsFor: 'building' stamp: 'cwp 3/16/2007 23:08'!
build: aModel
	| builder |
	builder _ self builder.
	^ aModel buildOn: builder.
	! !

!OBBuilderTest methodsFor: 'building' stamp: 'cwp 3/13/2007 22:25'!
buildNavigationPanel
	model _ self browser.
	^ self build: model navigationPanel.
	! !

!OBBuilderTest methodsFor: 'building' stamp: 'cwp 3/13/2007 22:26'!
buildWindow
	model _ self browser.
	^ self build: model.! !

!OBBuilderTest methodsFor: 'accessing' stamp: 'cwp 3/15/2007 22:35'!
columnWithFilter
	| metanode |
	metanode _ OBMetaNode named: 'Root'.
	metanode 
		childAt: #left put: (OBMetaNode named: 'Left');
		childAt: #right put: (OBMetaNode named: 'Right');
		filterClass: OBModalFilter.
	^ OBColumn 
		inPanel: self 
		metaNode: metanode
		node: self! !

!OBBuilderTest methodsFor: 'emulating' stamp: 'cwp 3/15/2007 22:36'!
left
	^ {self}! !

!OBBuilderTest methodsFor: 'emulating' stamp: 'cwp 3/15/2007 22:36'!
metaNode: aMetanode! !

!OBBuilderTest methodsFor: 'emulating' stamp: 'cwp 3/15/2007 22:36'!
right
	^ {self}! !

TestCase subclass: #OBCollectionNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBCollectionNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2007 22:34'!
testAncestryOfDescendent
	| node |
	node _ OBCollectionNode on: {OBClassNode on: self class}.
	self assert: (node isAncestorOf: (OBMethodNode on: #testAncestryOfDescendent inClass: self class))! !

!OBCollectionNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2007 22:29'!
testAncestryOfNodeInCollection
	| node |
	node _ OBCollectionNode on: {OBClassNode on: self class}.
	self assert: (node isAncestorOf: (OBClassNode on: self class))! !

TestCase subclass: #OBColumnTest
	instanceVariableNames: 'announcer column'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBColumnTest methodsFor: 'support' stamp: 'cwp 11/2/2006 00:35'!
addFactory: aBlock 
	| factory |
	factory := OBPluggableCommand action: aBlock.
	announcer observe: OBNodeCommandScan do: [:ann | ann addFactory: factory].
	^factory! !

!OBColumnTest methodsFor: 'updating' stamp: 'cwp 10/14/2006 18:04'!
announce: aClass 
	^ announcer announce: aClass! !

!OBColumnTest methodsFor: 'emulating' stamp: 'cwp 6/25/2006 00:04'!
announcer
	^ announcer! !

!OBColumnTest methodsFor: 'emulating' stamp: 'cwp 6/25/2006 00:40'!
browser
	^ self! !

!OBColumnTest methodsFor: 'emulating' stamp: 'cwp 6/25/2006 00:39'!
parentNodeForColumn: aColumn
	^ OBFakeNode parent: nil item: 'b'! !

!OBColumnTest methodsFor: 'emulating' stamp: 'cwp 6/28/2006 00:42'!
requestor
	^ OBRequestor for: self! !

!OBColumnTest methodsFor: 'support' stamp: 'cwp 6/25/2006 13:26'!
setUp
	announcer _ OBAnnouncer new.
	column _ OBColumn 
				inPanel: self 
				metaNode: OBFakeNode metagraph
				node: (OBFakeNode parent: nil item: 'a').

	! !

!OBColumnTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:35'!
test01MenuIncludesCommands
	| menu invoked |
	invoked := false.
	(self addFactory: [invoked := true]) label: 'test service'.
	menu := MenuMorph new.
	column menu: menu.
	(menu itemWithWording: 'test service') doButtonAction.
	self assert: invoked! !

!OBColumnTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:35'!
test02KeystrokeInvokesCommand
	| invoked |
	invoked := false.
	(self addFactory: [invoked := true]) keystroke: $s.
	column keystroke: $s from: nil.
	self assert: invoked! !

TestCase subclass: #OBDefinitionPanelTest
	instanceVariableNames: 'announcer panel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBDefinitionPanelTest methodsFor: 'emulating' stamp: 'cwp 10/13/2006 09:30'!
announce: aClass 
	^ announcer announce: aClass! !

!OBDefinitionPanelTest methodsFor: 'emulating' stamp: 'cwp 10/13/2006 00:09'!
announcer
	^ announcer! !

!OBDefinitionPanelTest methodsFor: 'support' stamp: 'cwp 10/13/2006 00:18'!
assertMenu: aMenu hasItemSending: aSelector
	aMenu items anySatisfy: [:ea | ea selector = aSelector]! !

!OBDefinitionPanelTest methodsFor: 'support' stamp: 'cwp 3/23/2007 23:59'!
menu
	^ (OBMorphBuilder build: panel) getMenu: false! !

!OBDefinitionPanelTest methodsFor: 'emulating' stamp: 'cwp 11/2/2006 00:35'!
scanCommands: ann 
	ann 
		addFactory: ((OBPluggableService action: 
					[:node | 
					self assert: (node isKindOf: OBTextSelection).
					executed := true]) 
				label: 'test')! !

!OBDefinitionPanelTest methodsFor: 'support' stamp: 'cwp 10/13/2006 10:04'!
setUp
	announcer _ OBAnnouncer new.
	panel _ OBDefinitionPanel inBrowser: self.
	! !

!OBDefinitionPanelTest methodsFor: 'tests' stamp: 'cwp 3/23/2007 23:59'!
test01MenuHasEditingItems
	| menu |
	menu _ self menu.
	self assertMenu: menu hasItemSending: #find.
	self assertMenu: menu hasItemSending: #findAgain.
	self assertMenu: menu hasItemSending: #setSearchString.
	self assertMenu: menu hasItemSending: #again.
	self assertMenu: menu hasItemSending: #undo.
	self assertMenu: menu hasItemSending: #copySelection.
	self assertMenu: menu hasItemSending: #cut.
	self assertMenu: menu hasItemSending: #paste.
	self assertMenu: menu hasItemSending: #pasteRecent.
	self assertMenu: menu hasItemSending: #accept.
	self assertMenu: menu hasItemSending: #cancel.! !

!OBDefinitionPanelTest methodsFor: 'tests' stamp: 'cwp 3/23/2007 23:59'!
test02MenuIncludesCommands
	| menu |
	announcer observe: OBTextCommandScan
		do: [:ann | ann addFactory: (OBPluggableCommand new label: 'test')].
	menu := self menu.
	self deny: (menu itemWithWording: 'test') isNil! !

!OBDefinitionPanelTest methodsFor: 'tests' stamp: 'cwp 3/23/2007 23:59'!
test03CommandsGetExecuted
	| menu executed |
	executed := false.
	announcer observe: OBTextCommandScan
		do: 
			[:ann | 
			ann 
				addFactory: ((OBPluggableCommand action: [executed := true]) label: 'test')].
	menu := self menu.
	(menu itemWithWording: 'test') doButtonAction.
	self assert: executed! !

!OBDefinitionPanelTest methodsFor: 'tests' stamp: 'cwp 3/23/2007 23:59'!
test04InactiveCommandsAreHidden
	| menu |
	announcer observe: OBTextCommandScan
		do: 
			[:ann | 
			ann 
				addFactory: ((OBPluggableCommand action: [] active: [false]) label: 'test')].
	menu := self menu.
	self assert: (menu itemWithWording: 'test') isNil! !

!OBDefinitionPanelTest methodsFor: 'tests' stamp: 'cwp 3/3/2007 22:37'!
test05SilentChangeAllowedIfNotDirty
	| ann |
	ann _ announcer announce: OBAboutToChangeSilently.
	self deny: ann isVetoed.! !

!OBDefinitionPanelTest methodsFor: 'tests' stamp: 'cwp 3/24/2007 00:00'!
test06SilentChangeVetoedIfDirty
	| ann morph |
	morph _ OBMorphBuilder build: panel.
	morph hasUnacceptedEdits: true.
	ann _ announcer announce: OBAboutToChangeSilently.
	self assert: ann isVetoed.! !

TestCase subclass: #OBOpenTest
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

OBOpenTest subclass: #OBLibraryOpenTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBLibraryOpenTest methodsFor: 'accessing' stamp: 'cwp 1/21/2007 23:42'!
metagraph
	| fake |
	fake _ OBMetaNode new.
	fake childAt: #children put: fake.
	^ fake! !

!OBLibraryOpenTest methodsFor: 'tests' stamp: 'avi 9/17/2005 01:16'!
testGraphRootSelection
	| parent child |
	parent _ OBFakeNode parent: nil item: 'parent'.
	child _ OBFakeNode parent: parent item: 'a'.
	self create: [OBBrowser 
					metaNode: self metagraph
					root: parent
					selection: child].
	self shouldnt: [browser navigationPanel] raise: Error! !

!OBLibraryOpenTest methodsFor: 'tests' stamp: 'avi 9/17/2005 01:17'!
testGraphRootSelectionPanels
	| parent child panels |
	parent _ OBFakeNode parent: nil item: 'parent'.
	child _ OBFakeNode parent: parent item: 'a'.
	panels _ {OBColumnPanel new. OBDefinitionPanel new}.
	self create: [OBBrowser 
					metaNode: self metagraph
					root: parent
					selection: child
					panels: panels].
	self assert: browser navigationPanel minPanes = 1.
	self assert: browser navigationPanel maxPanes = 1.
	self assert: browser root = parent.
	self assert: browser currentNode = child.
	self assert: browser panels size = panels size.
	self assert: (browser panels includesAllOf: panels)! !

!OBOpenTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/5/2004 15:55'!
isAbstract
	^ self name = #OBOpenTest! !

!OBOpenTest methodsFor: 'actions' stamp: 'cwp 12/5/2004 15:54'!
create: aBlock
	self 
		shouldnt: [browser _ aBlock value]
		raise: OBBrowseRequest! !

!OBOpenTest methodsFor: 'actions' stamp: 'cwp 12/5/2004 15:52'!
open: aBlock
	[aBlock value]
		on: OBBrowseRequest
		do: [:n | browser _ n browser].
	self assert: browser notNil! !

TestCase subclass: #OBPluggableCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBPluggableCommandTest methodsFor: 'emulating' stamp: 'cwp 7/9/2006 12:52'!
height
	^ 16! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:39'!
test01ExecuteEvaluatesAction
	| called factory command |
	called _ false.
	factory _ OBPluggableCommand action: [called _ true].
	command _ factory on: nil for: nil.
	command execute.
	self assert: called.! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:39'!
test02ActionCanBeAMessageSend
	| called factory send command |
	called _ false.
	send _ MessageSend receiver: [called _ true] selector: #value.
	factory _ OBPluggableCommand action: send.
	command _ factory on: nil for: nil.
	command execute.
	self assert: called.! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:40'!
test03ActionReceivesRequestor
	| factory requestor command |
	requestor _ nil.
	factory _ OBPluggableCommand action: [:arg1 :arg2 | requestor _ arg2].
	command _ factory on: nil for: self.
	command execute.
	self assert: requestor == self.! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:40'!
test03ActionRecievesNode
	| factory node command |
	node _ nil.
	factory _ OBPluggableCommand action: [:arg1 :arg2 | node _ arg1].
	command _ factory on: self for: nil.
	command execute.
	self assert: node == self.! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:40'!
test04ConditionExecutesByDefault
	| factory command |
	factory _ OBPluggableCommand action: [].
	command _ factory on: nil for: nil.
	self assert: command isActive
	! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:40'!
test06MenuItemExecutesAction
	| menu factory called command |
	called _ false.
	menu _ MenuMorph new.
	factory _ OBPluggableCommand action: [called _ true].
	command _ factory on: nil for: nil.
	command addItemToMenu: menu.
	menu items first doButtonAction.
	self assert: called! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:40'!
test07MenuItemEnabledByDefault
	| menu factory command |
	menu _ MenuMorph new.
	factory _ OBPluggableCommand new.
	command _ factory on: nil for: nil.
	command addItemToMenu: menu.
	self assert: menu items first isEnabled! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:41'!
test08MenuItemReflectsCondition
	
	| factory command |
	factory _ OBPluggableCommand new enabled: [false].
	command _ factory on: nil for: self.
	self deny: (command isEnabled).
	! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:41'!
test09MenuReflectsLabel
	| menu factory command |
	menu _ MenuMorph new.
	factory _ OBPluggableCommand new label: 'a fine factory'.
	command _ factory on: nil for: self.
	command addItemToMenu: menu.
	self assert: menu items first contents = 'a fine factory'! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:41'!
test10MenuDisplaysKeystroke
	| menu factory command |
	menu _ MenuMorph new.
	factory _ OBPluggableCommand new 
				label: 'a fine factory';
				keystroke: $f.
	command _ factory on: nil for: self.
	command addItemToMenu: menu.
	self assert: menu items first contents = 'a fine factory (f)'! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:41'!
test11MenuDisplaysIcon
	| menu factory pref command |
	pref _ Preferences menuWithIcons.
	[Preferences enableGently: #menuWithIcons.
	menu _ MenuMorph new.
	factory _ OBPluggableCommand new 
				label: 'a fine factory';
				icon: self.
	command _ factory on: nil for: self.
	command addItemToMenu: menu.
	self assert: menu lastItem icon == self]
		ensure: [Preferences setPreference: #menuWithIcons toValue: pref]! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:42'!
test12ButtonCreatedWithLabel
	| factory button |
	factory _ OBPluggableCommand new.
	factory buttonLabel: 'serv'.
	button _ factory buttonMorph.
	self assert: (button isKindOf: PluggableButtonMorph).
	self assert: button label contents = 'serv'! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:42'!
test13CommandIsMenuOnlyByDefault
	| factory |
	factory := OBPluggableCommand new.
	self deny: factory wantsButton! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:42'!
test14CommandWithButtonLabelWantsButton
	| factory |
	factory := OBPluggableCommand new.
	factory buttonLabel: 'serv'.
	self assert: factory wantsButton! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:42'!
test15CondReceivesRequestor
	| factory requestor command |
	requestor _ nil.
	factory _ OBPluggableCommand action: [] active: [:n :r | requestor _ r].
	command _ factory on: factory for: self.
	command isActive.
	self assert: requestor == self! !

!OBPluggableCommandTest methodsFor: 'emulating' stamp: 'cwp 7/9/2006 12:52'!
width
	^ 16! !

TestCase subclass: #OBTextSelectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBTextSelectionTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/14/2006 20:17'!
test01Text
	| selection |
	selection _ OBTextSelection on: (3 to: 5) inText: 'abcdefghijk'.
	self assert: selection text = 'cde'.
! !

!OBTextSelectionTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/14/2006 20:17'!
test02FullText
	| selection |
	selection _ OBTextSelection on: (3 to: 5) inText: 'abcdefghijk'.
	self assert: selection fullText = 'abcdefghijk'.! !

!OBTextSelectionTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/14/2006 20:26'!
test03Selector
	| selection text |
	text _ 'self foo: #a bar: #b.  '.
	selection _ OBTextSelection 
					on: (1 to: text size) 
					inText: text.
	self assert: selection selector = #foo:bar:

! !

OBNode subclass: #OBFakeNode
	instanceVariableNames: 'item parent children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBFakeNode class methodsFor: 'browsing' stamp: 'cwp 3/12/2007 23:47'!
metagraph
	| fake |
	fake _ OBMetaNode new.
	fake childAt: #children put: fake.
	^ fake! !

!OBFakeNode class methodsFor: 'instance creation' stamp: 'cwp 12/15/2003 22:06'!
parent: aFakeNode item: aString
	^ self new parent: aFakeNode; item: aString! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 3/13/2007 00:33'!
adopt: aNode
	aNode parent removeChild: aNode.
	aNode parent: self.
	children _ self children copyWith: aNode.
	^ aNode! !

!OBFakeNode methodsFor: 'actions' stamp: 'cwp 3/13/2007 00:08'!
beZ
	item _ 'z'.
	! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 1/23/2004 21:42'!
children
	^ children 
		ifNil: [children _ (self item endsWith: 'c')
					ifTrue: [Array new]
					ifFalse: [#($a $b $c) collect: [:i | OBFakeNode parent: self item: i asString]]]! !

!OBFakeNode methodsFor: 'actions' stamp: 'cwp 3/13/2007 00:33'!
createZ
	^ self adopt: (OBFakeNode parent: self item: 'z')! !

!OBFakeNode methodsFor: 'actions' stamp: 'cwp 3/13/2007 00:20'!
delete
	parent ifNotNil: [parent removeChild: self].
	! !

!OBFakeNode methodsFor: 'drag and drop' stamp: 'cwp 3/13/2007 00:43'!
dropOnFakeNode: aNode
	aNode adopt: self.
	aNode signalSelection! !

!OBFakeNode methodsFor: 'drag and drop' stamp: 'cwp 3/2/2004 21:40'!
dropSelector
	^ #dropOnFakeNode:! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 12/5/2004 16:16'!
isAncestorOf: aNode
	| ancestor |
	aNode name = self name ifTrue: [^ true].
	ancestor _ aNode.
	[ancestor isNil]
		whileFalse: [ancestor == self ifTrue: [^ true].
					ancestor _ ancestor parent].
	^ false! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/7/2003 19:18'!
item
	^ item ifNil: [item _ '']! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/7/2003 19:09'!
item: aSymbol
	item _ aSymbol! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 12/15/2003 22:05'!
name
	^ self parentName, self item ! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 2/25/2004 21:49'!
parent
	^ parent! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/15/2003 22:01'!
parent: aFakeNode
	parent _ aFakeNode! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/15/2003 22:04'!
parentName
	^ (parent ifNil: [''] ifNotNil: [parent name])! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 2/25/2004 21:53'!
removeChild: aFakeNode
	children _ self children copyWithout: aFakeNode! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 3/13/2007 00:24'!
root
	| node |
	node _ self parent.
	[node parent notNil] whileTrue: [node _ node parent].
	^ node! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 12/15/2003 22:03'!
text
	^ self name! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 9/18/2005 14:58'!
text: aText
	self item:( aText asString allButFirst: (self parentName size)).
	self demandSelection.
	^ true! !
